package me.km.effects;

import me.km.api.GlobalText;
import me.km.api.Module;
import me.km.api.ModuleCommand;
import me.km.items.ItemWand;
import me.km.permissions.Permissions;
import net.minecraft.command.ICommandSender;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;

public class CommandWand extends ModuleCommand
{   
    public CommandWand(Module m) 
    {
        super("wand", m);
        super.setDescription("Belegt deinen Zauberstab mit einem Effekt");
        super.setUsage("/wand <effect>");
        super.setPermission(Permissions.WAND);
    }

    @Override
    public boolean execute(ICommandSender cs, String[] arg) 
    {
        if(!(cs instanceof EntityPlayer))
        {
            this.getModule().send(cs, GlobalText.onlyPlayer());
            return true;
        }
        EntityPlayer p = (EntityPlayer) cs;
        if(arg.length >= 1)
        {     
            ItemStack stack = p.getHeldItemMainhand();
            if(stack.getItem() instanceof ItemWand)
            {
                this.getModule().send(cs, "Du musst einen Zauberstab in der Hand halten.");
                return true;
            }
            Class<? extends ActiveEffectBase> c = EffectUtils.getEffectClass(arg[0]);
            if(c == null)
            { 
                this.getModule().send(cs, "Dieser aktive Effekt existiert nicht.");
                return true;
            }
            stack.setStackDisplayName("§6" + arg[0]);
            return true;
        } 
        return false;
    }
}
