package me.km.inventory;

import me.km.snuviscript.SnuviInventory;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.inventory.ClickType;
import net.minecraft.inventory.ContainerChest;
import net.minecraft.inventory.IInventory;
import net.minecraft.inventory.InventoryBasic;
import net.minecraft.item.ItemStack;
import net.minecraft.network.play.server.SPacketOpenWindow;

public class CustomContainer extends ContainerChest
{
    public CustomContainer(String title, int slotCount, EntityPlayerMP p) 
    {
        super(p.inventory, new EntityInventory(title, slotCount, p), p);
    }
    
    public CustomContainer(SnuviInventory inv, EntityPlayerMP p) 
    {
        super(p.inventory, inv, p);
    }
    
    public InventoryBasic getShownInventory()
    {
        return (InventoryBasic) this.getLowerChestInventory();
    }
    
    public void openForPlayer(EntityPlayerMP p)
    {
        if(p.openContainer != p.inventoryContainer)
        {
            p.closeScreen();
        }
        p.getNextWindowId();
        IInventory inv = this.getLowerChestInventory();
        p.connection.sendPacket(new SPacketOpenWindow(p.currentWindowId, "minecraft:container", inv.getDisplayName(), inv.getSizeInventory()));
        p.openContainer = this;
        p.openContainer.windowId = p.currentWindowId;
        p.openContainer.addListener(p);
    }
    
    public boolean noClicking(int slotId, int dragType, ClickType clickTypeIn, EntityPlayerMP player)
    {
        return true;
    }
    
    @Override
    public final ItemStack slotClick(int slotId, int dragType, ClickType clickTypeIn, EntityPlayer p) 
    {
        if(p instanceof EntityPlayerMP)
        {
            EntityPlayerMP player = (EntityPlayerMP) p;
            if(noClicking(slotId, dragType, clickTypeIn, player))
            {
                onCanceledClick(slotId, dragType, clickTypeIn, player);
                return ItemStack.EMPTY;
            }
        }
        return super.slotClick(slotId, dragType, clickTypeIn, p);
    }  
    
    public void onCanceledClick(int slotId, int dragType, ClickType clickTypeIn, EntityPlayerMP player)
    {
    }
}
